package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 类型枚举
 * @date 2018年10月11日 下午3:33:22
 */

public enum BaseDiagnoseTypeEnum implements KeyedNamed {

    B1(1, "等于术语本身"),
    B2(2, "存在比较"),
    B3(3, "主诉现病史正则"),
    B4(4, "既往史正则");

    @Setter
    private int key;

    @Setter
    private String name;

    BaseDiagnoseTypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static BaseDiagnoseTypeEnum getEnum(int key) {
        for (BaseDiagnoseTypeEnum item : BaseDiagnoseTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static BaseDiagnoseTypeEnum getEnum(String value) {
        for (BaseDiagnoseTypeEnum item : BaseDiagnoseTypeEnum.values()) {
            if (item.getName().equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        BaseDiagnoseTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
